org.eclipse.actf.util.vocab

## Class Vocabulary

- java.lang.Object
- - org.eclipse.actf.util.vocab.Vocabulary

    public class Vocabulary
    extends Object

Vocabulary treats the meaning of instances of `IEvalTarget` by using `IProposition`. `IProposition` represents a question whether a `IEvalTarget` instance is matched with the proposition or not. Actual meaning is provided by the term implementation which extends `AbstractTerms`. Each instance of the `IEvalTarget` is associated with a term implementation. The following is the flow to get the meaning of the `IEvalTarget` instance.

      1. get an IProposition from Vocabulary.
      2. call IProposition.eval(IEvalTarget) method with an IEvalTarget.
      3. IProposition.eval(IEvalTarget) method gets the associated term.
      4. IProposition.eval(IEvalTarget) method calls the method corresponding to itself with the IEvalTarget.
         For example, isClickable() calls AbstractTerms.isClickable(IEvalTarget).

### Nested Class Summary

Nested Classes
`static class` `Vocabulary.FlashMode`

### Constructor Summary

Constructors
Constructor and Description
`Vocabulary()`

### Method Summary

Methods
`static IProposition` `and(IProposition... args)`
`static IProposition` `find(String str, boolean exact)`
`static IProposition` `get(String name)`
`static Vocabulary.FlashMode` `getNormalFlashMode()`
`static Vocabulary.FlashMode` `getWindowlessFlashMode()`
`static IProposition` `hasContent()` Having content means that the element has content to be displayed in the aiBrowser
`static IProposition` `hasReadingContent()`
`static IProposition` `isAccessKey(char key)`
`static IProposition` `isAlterable()`
`static IProposition` `isBlockJumpPointB()`
`static IProposition` `isBlockJumpPointF()`
`static IProposition` `isButton()`
`static IProposition` `isCheckbox()`
`static IProposition` `isChecked()`
`static IProposition` `isClickable()`
`static IProposition` `isCombobox()`
`static IProposition` `isConnectable()`
`static IProposition` `isEditable()` text box, text area, password, combo box, check box, radio button, and so on.
`static IProposition` `isEmbeddedObject()`
`static IProposition` `isFileEdit()`
`static IProposition` `isFlashLastNode()`
`static IProposition` `isFlashTopNode()`
`static IProposition` `isHeading()`
`static IProposition` `isHeading1()`
`static IProposition` `isHeading2()`
`static IProposition` `isHeading3()`
`static IProposition` `isHeading4()`
`static IProposition` `isHeading5()`
`static IProposition` `isHeading6()`
`static IProposition` `isImage()`
`static IProposition` `isInputable()` text box, text area, password
`static IProposition` `isLabel()`
`static IProposition` `isLink()`
`static IProposition` `isListItem()`
`static IProposition` `isListTop()` OL, UL, DL tags
`static IProposition` `isMedia()`
`static IProposition` `isMSAAFlash()`
`static IProposition` `isMultilineEdit()`
`static IProposition` `isMultiSelectable()`
`static IProposition` `isPassword()`
`static IProposition` `isRadio()`
`static IProposition` `isReachable(Node baseNode)`
`static boolean` `isReadNoAltImage()`
`static boolean` `isReadNoAltImageLink()`
`static boolean` `isReadNullAltImage()`
`static boolean` `isReadNullAltImageLink()`
`static IProposition` `isReducible()`
`static IProposition` `isSelectable()`
`static IProposition` `isSelectOption()`
`static boolean` `isSkipIconLink()`
`static IProposition` `isSubmit()`
`static IProposition` `isTextarea()`
`static IProposition` `isTextbox()`
`static IProposition` `isValidNode()`
`static IProposition` `isVisibleNode()`
`static IProposition` `isVisitedLink()`
`static IProposition` `nodeLocation(Node refNode, boolean backward)`
`static IProposition` `or(IProposition... args)`
`static IProposition` `startsWith(String str, boolean exact)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Vocabulary

    public Vocabulary()

### Method Detail

#### or

    public static IProposition or(IProposition... args)

Parameters:
  `args` - the instances of IPropsition to be concatenated by "OR"
Returns:
  the result of the logical OR operation

#### and

    public static IProposition and(IProposition... args)

Parameters:
  `args` - the instances of IPropsition to be concatenated by "AND"
Returns:
  the result of the logical AND operation

#### get

    public static IProposition get(String name)

#### isClickable

    public static IProposition isClickable()

Returns:
  the instance of `IProposition` which evaluates whether a node is clickable or not

#### hasContent

    public static IProposition hasContent()

Having content means that the element has content to be displayed in the aiBrowser

Returns:
  the instance of `IProposition` which evaluates whether a node has content

#### isEditable

    public static IProposition isEditable()

text box, text area, password, combo box, check box, radio button, and so on.

Returns:
  the instance of `IProposition` which evaluates whether a node can be edited.

#### isSelectable

    public static IProposition isSelectable()

Returns:
  the instance of `IProposition` which evaluates whether a node has some options to be selected.

#### isEmbeddedObject

    public static IProposition isEmbeddedObject()

Returns:
  the instance of `IProposition` which evaluates whether a node is embedded object.

#### isValidNode

    public static IProposition isValidNode()

Returns:
  the instance of `IProposition` which evaluates whether a node is valid for aiBrowser's tree item.

#### isVisibleNode

    public static IProposition isVisibleNode()

Returns:
  the instance of `IProposition` which evaluates whether a node is visible or not.

#### isInputable

    public static IProposition isInputable()

text box, text area, password

Returns:
  the instance of `IProposition` which evaluates whether a node can be input text.

#### isButton

    public static IProposition isButton()

Returns:
  the instance of `IProposition` which evaluates whether a node is button or not.

#### isListItem

    public static IProposition isListItem()

Returns:
  the instance of `IProposition` which evaluates whether a node is list item or not

#### isListTop

    public static IProposition isListTop()

OL, UL, DL tags

Returns:
  the instance of `IProposition` which evaluates whether a node is list element or not

#### isCheckbox

    public static IProposition isCheckbox()

Returns:
  the instance of `IProposition` which evaluates whether a node is check box or not

#### isChecked

    public static IProposition isChecked()

Returns:
  the instance of `IProposition` which evaluates whether a node is checked or not

#### isLabel

    public static IProposition isLabel()

Returns:
  the instance of `IProposition` which evaluates whether a node is label element or not

#### isLink

    public static IProposition isLink()

Returns:
  the instance of `IProposition` which evaluates whether a node is anchor element or not

#### isVisitedLink

    public static IProposition isVisitedLink()

Returns:
  the instance of `IProposition` which evaluates whether a node is visited link or not

#### isRadio

    public static IProposition isRadio()

Returns:
  the instance of `IProposition` which evaluates whether a node is radio button or not

#### isSubmit

    public static IProposition isSubmit()

Returns:
  the instance of `IProposition` which evaluates whether a node is submit button or not

#### isFileEdit

    public static IProposition isFileEdit()

Returns:
  the instance of `IProposition` which evaluates whether a node is file edit or not

#### isCombobox

    public static IProposition isCombobox()

Returns:
  the instance of `IProposition` which evaluates whether a node is combo box or not

#### isTextarea

    public static IProposition isTextarea()

Returns:
  the instance of `IProposition` which evaluates whether a node is text area or not

#### isTextbox

    public static IProposition isTextbox()

Returns:
  the instance of `IProposition` which evaluates whether a node is text box or not

#### isPassword

    public static IProposition isPassword()

Returns:
  the instance of `IProposition` which evaluates whether a node is password or not

#### isSelectOption

    public static IProposition isSelectOption()

Returns:
  the instance of `IProposition` which evaluates whether a node is option of select form or not

#### isImage

    public static IProposition isImage()

Returns:
  the instance of `IProposition` which evaluates whether a node is image element or not

#### isMultilineEdit

    public static IProposition isMultilineEdit()

Returns:
  the instance of `IProposition` which evaluates whether a node is text edit control having multiple lines

#### isReducible

    public static IProposition isReducible()

Returns:
  the instance of `IProposition` which evaluates whether a node can be omitted to create simplified tree by fennec auto translator

#### isHeading

    public static IProposition isHeading()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading element or not

#### isHeading1

    public static IProposition isHeading1()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading level 1 element or not

#### isHeading2

    public static IProposition isHeading2()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading level 2 element or not

#### isHeading3

    public static IProposition isHeading3()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading level 3 element or not

#### isHeading4

    public static IProposition isHeading4()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading level 4 element or not

#### isHeading5

    public static IProposition isHeading5()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading level 5 element or not

#### isHeading6

    public static IProposition isHeading6()

Returns:
  the instance of `IProposition` which evaluates whether a node is heading level 6 element or not

#### find

    public static IProposition find(String str,
                    boolean exact)

Parameters:
  `str` - the string to be found
  `exact` - if true then case-sensitive
Returns:
  the instance of `IProposition` which evaluates whether a node has the string

#### startsWith

    public static IProposition startsWith(String str,
                          boolean exact)

Parameters:
  `str` - the string to be found
  `exact` - if true then case-sensitive
Returns:
  the instance of `IProposition` which evaluates whether a node has string which starts with str

#### nodeLocation

    public static IProposition nodeLocation(Node refNode,
                            boolean backward)

Parameters:
  `refNode` - the reference node to be compared
  `backward` - the target node is appeared before the refNode or not
Returns:
  the instance of `IProposition` which evaluates whether a node is appeared before or after the reference node

#### isAccessKey

    public static IProposition isAccessKey(char key)

Parameters:
  `key` - the character of the access key
Returns:
  the instance of `IProposition` which evaluates whether a node has the access key

#### isConnectable

    public static IProposition isConnectable()

Returns:
  the instance of `IProposition` which evaluates whether a node can be read with next sibling or not

#### hasReadingContent

    public static IProposition hasReadingContent()

Returns:
  the instance of `IProposition` which evaluates whether a node has content can be read.

#### isBlockJumpPointF

    public static IProposition isBlockJumpPointF()

Returns:
  the instance of `IProposition` which evaluates whether a node is suitable for block jump point in forward direction

#### isBlockJumpPointB

    public static IProposition isBlockJumpPointB()

Returns:
  the instance of `IProposition` which evaluates whether a node is suitable for block jump point in backward direction

#### isMultiSelectable

    public static IProposition isMultiSelectable()

Returns:
  the instance of `IProposition` which evaluates whether a node is multi selectable list

#### isMedia

    public static IProposition isMedia()

Returns:
  the instance of `IProposition` which evaluates whether a node is sound or video object

#### isFlashTopNode

    public static IProposition isFlashTopNode()

Returns:
  the instance of `IProposition` which evaluates whether a node is Flash element

#### isFlashLastNode

    public static IProposition isFlashLastNode()

Returns:
  the instance of `IProposition` which evaluates whether a node is the last node of Flash element

#### isMSAAFlash

    public static IProposition isMSAAFlash()

Returns:
  the instance of `IProposition` which evaluates whether a node is Flash element from MSAA

#### isReachable

    public static IProposition isReachable(Node baseNode)

Parameters:
  `baseNode` - the node to be checked for reaching
Returns:
  the instance of `IProposition` which evaluates whether a node can be read with next element in HTML level.

#### isAlterable

    public static IProposition isAlterable()

Returns:
  the instance of `IProposition` which evaluates whether a node can be added alternative text

#### getNormalFlashMode

    public static Vocabulary.FlashMode getNormalFlashMode()

Returns:
  the mode for normal Flash

#### getWindowlessFlashMode

    public static Vocabulary.FlashMode getWindowlessFlashMode()

Returns:
  the mode for windowless flash mode

#### isReadNoAltImage

    public static boolean isReadNoAltImage()

Returns:
  whether the system reads no alt image

#### isReadNullAltImage

    public static boolean isReadNullAltImage()

Returns:
  whether the system read null alt image

#### isReadNoAltImageLink

    public static boolean isReadNoAltImageLink()

Returns:
  whether the system reads no alt image link

#### isReadNullAltImageLink

    public static boolean isReadNullAltImageLink()

Returns:
  whether the system reads null alt image link

#### isSkipIconLink

    public static boolean isSkipIconLink()

Returns: